#ifndef __THREAD_H__
#define __THREAD_H__

#include "condition.h"
#include <pthread.h>

class Thread {
 private:
  pthread_t thr;
  CondSimple kicker;
  bool stop;
  static void* run(void* it) {
    ((Thread*)it)->thr = pthread_self();
cerr<<"Thread::run"<<endl;
    ((Thread*)it)->idle(-1);
cerr<<"Thread::run: starting"<<endl;
    ((Thread*)it)->func();
cerr<<"Thread::run: exiting"<<endl;
    ((Thread*)it)->exit();
  };
  virtual void func(void) {
cerr<<"Pure virtual thread started and finished"<<endl;
  };
  bool valid;
 public:
  Thread(void):stop(false) {
cerr<<"Thread::Thread"<<endl;
    valid=false;
    if(pthread_create(&thr,NULL,&run,(void*)this) != 0) return;
cerr<<"Thread::Thread: thread created"<<endl;
    pthread_detach(thr);
cerr<<"Thread::Thread: thread detached"<<endl;
    valid=true; 
  };
  ~Thread(void) {
cerr<<"Thread::~Thread"<<endl;
    exit();
  };
  void attention(void) {
cerr<<"Thread::attention"<<endl;
    kicker.signal();
  };
  void exit(void) {
cerr<<"Thread::exit"<<endl;
    if(pthread_equal(pthread_self(),thr)) {
      kicker.block(); valid=false; kicker.signal_nonblock(); kicker.unblock();
      pthread_exit(NULL);
    };
    stop=true;
    while(valid) kicker.wait();
  };
  void idle(int t = 0) {
cerr<<"Thread::idle: "<<t<<endl;
    if(pthread_equal(pthread_self(),thr)) {
cerr<<"Thread::idling"<<endl;
      if(stop) exit();
      if(t<0) { kicker.wait(); } else { kicker.wait(t); };
      if(stop) exit();
    };
  };
  operator bool(void) { return valid; };
};

#endif // __THREAD_H__
